// основан на проекте https://github.com/derekstavis/nrf24le1-libbcm2835 .
// страничка проекта http://homes-smart.ru/index.php/oborudovanie/bez-provodov-2-4-ggts/54-programmirovanie-nrf24le1-cherez-raspberry-pi

#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "nrf24le1.h"

void nrf_save_data(uint8_t * buf, uint16_t count, uint8_t * fname)
{
	size_t size_writed = 0, idx = 0;
	FILE * fd;

	fd = fopen(fname, "w");

	while(idx < count)
	{
		size_writed = fwrite(&buf[idx], 1, (count - idx), fd);
		idx = size_writed + idx;
	}
	fclose(fd);
}

void nrf_restore_data(uint8_t * buf, uint16_t count, uint8_t * fname)
{
	FILE * fd;
	fd = fopen(fname, "r");
	fread(buf, 1, count, fd);
	fclose(fd);
}

static void usage(char *name)
{
    fprintf(stderr, "Прошивка nRF24LE1 через Raspberry PI.  http://homes-smart.ru/\nОригинальный проект https://github.com/derekstavis/nrf24le1-libbcm2835\nusage:\n");
    fprintf(stderr, " %s test -информация\n", name);
    fprintf(stderr, " %s write -запись прошивки файла main.bin.\n", name);
    fprintf(stderr, " %s read -чтение прошивки в файл mainread.bin.\n", name);
}

int main(int argc, char **argv) {
  
    if(argc < 2){   /* we need at least one argument */
        usage(argv[0]);
        exit(1);
    }
  
	uint8_t bufread[17000];
	unsigned long off = 0;
	size_t count =16384;

	memset(bufread, 0, sizeof(bufread));

	nrf24le1_init();

	enable_program(1);

	if(strcasecmp(argv[1], "test") == 0) da_test_show();
	   
	else
	if(strcasecmp(argv[1], "write") == 0){
#if 1
	nrf_restore_data(bufread, count, "./main.bin");
	uhet_write(bufread, 16384, &off);
//	nrf_save_data(bufread, count, "./firmw/blink-dump.img");
#endif
	} else 
	if(strcasecmp(argv[1], "read") == 0){

#if 1
	memset(bufread, 0, sizeof(bufread));
	uhet_read(bufread, count, &off);

	nrf_save_data(bufread, count, "./main-dump.bin");
#endif
	}
	//da_erase_all_store();

	enable_program(0);

	wiring_destroy();
	
  	return 0;
}
